#include <stdlib.h>
#include <GL/glut.h>
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <string.h>


/* GLOBAL VARIABLES */

int pic = 0;
const float pi = 3.14159265358972;
float angle = 180.0;
float eyez = 0.0, eyex = 29.0;
float centerx = 0.0, centerz = 6.0;
int mainWin, mapWin;
int width = 400, height = 400;
int numofexhibits = 4;
int exhibit[5][2];

/* Light Properties */
GLfloat light_ambient[] = {.6, .6, .6, 1};
GLfloat light_diffuse[] = {.75, .75, .75, 1};
GLfloat light_specular[] = {1.0, 1.0, 1.0, 0.6};
GLfloat light_position[] = {0, 25.0, 0.0, 0.2};
GLfloat map_light_position[] = {-1.0, 0.0, 0.0, 0.0};

double min(double a, double b)
{
	return (a < b) ? a : b;
}

double max(double a, double b)
{
	return (a > b) ? a : b;
}

// converts an integer into an array of characters
// For example 10 -> 010
char *number(int num)							
{
	int numdigits = int(floor(log(num) / log(10)));
	char *str = new char[4];
	str[3] = 0;
	for (int i=2; i>=0; i--)
	{
		if (i > numdigits) str[2-i] = '0';
		else
		{
			int digit = int(num/pow(10,i));
			str[2-i] = (char)(48+digit);
			num -= int(digit*pow(10,i));
		}
	}
	return str;
}


// modified screenShot function
int screenShot()
{
  // we will store the image data here
  unsigned char *pixels;
  // the thingy we use to write files
  FILE * shot;
  // we get the width/height of the screen into this array
  int screenStats[4];

  // get the width/height of the window
  glGetIntegerv(GL_VIEWPORT, screenStats);

  // generate an array large enough to hold the pixel data 
  // (width*height*bytesPerPixel)
  pixels = new unsigned char[screenStats[2]*screenStats[3]*3];
  // read in the pixel data, TGA's pixels are BGR aligned
  glReadPixels(0, 0, screenStats[2], screenStats[3], GL_BGR, 
                                   GL_UNSIGNED_BYTE, pixels);

  // open the file for writing. If unsucessful, return 1
		
  char *filename = new char[12];
  const char *temp = number(pic);
  cout << "temp: " << temp << endl;
  filename[0]='i';
  filename[1]='m';
  filename[2]='g';
  filename[3]='/';
  for(int x=0; x<3; x++)
    filename[x+4]=temp[x];
  filename[7]='.';
  filename[8]='t';
  filename[9]='g';
  filename[10]='a';
  filename[11]=0;

  cout << "filename: " << filename << endl;
	
  if((shot=fopen(filename, "wb"))==NULL) return 1;

  // this is the tga header it must be in the beginning of 
  // every (uncompressed) .tga
  unsigned char TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0};
  // the header that is used to get the dimensions of the .tga
  // header[1]*256+header[0] - width
  // header[3]*256+header[2] - height
  // header[4] - bits per pixel
  // header[5] - ?
  unsigned char header[6]={((int)(screenStats[2]%256)),
                   ((int)(screenStats[2]/256)),
                   ((int)(screenStats[3]%256)),
		   ((int)(screenStats[3]/256)),24,0};

  // write out the TGA header
  fwrite(TGAheader, sizeof(unsigned char), 12, shot);
  // write out the header
  fwrite(header, sizeof(unsigned char), 6, shot);
  // write the pixels
  fwrite(pixels, sizeof(unsigned char), 
                 screenStats[2]*screenStats[3]*3, shot);

  // close the file
  fclose(shot);
  // free the memory
  delete [] pixels;

  // return success
  return 0;
}

void drawHalls(void)
{
  glPushMatrix();                   // wall - hallway #1 
    glColor3f(1.0, 0.843, 0.506);
    glTranslatef( 0, 5, 5);
    glScalef(40, 11, 1);  
    glutSolidCube(1.0);
  glPopMatrix();
      
  glPushMatrix();                   // wall - hallway #1
    glTranslatef( 0, 5, -5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(25, 5, 19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(-25, 5, 19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(0, 5, 30);
    glScalef(90, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glTranslatef(25, 5, 45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glTranslatef(25, 5, -45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(25, 5, -19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(-25, 5, -19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(0, 5, -30);
    glScalef(90, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glTranslatef(-25, 5, 45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glTranslatef(-25, 5, -45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();					// door
    glColor3f(.9, .5, .18);
    glTranslatef(30, 3, 0);
    glScalef(1.12, 7, 3);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();					// door knob
    glColor3f(1, 1, 0);
    glTranslatef(29.3, 3.2, 1.2);
    glScalef(.2, .2, .2);
    glutSolidSphere(1, 15, 15);
  glPopMatrix();
}

void drawExhibits(void)
{
  glPushMatrix();                   // exhibit 0
    glColor3f(1.2, 1, 0);
    glTranslatef(0, 5.0, -4.9);
    glScalef(3, 3, 1);
    glutSolidCube(1.0);
    exhibit[0][0] = 0;
    exhibit[0][1] = -5;
  glPopMatrix();

  glPushMatrix();                   // exhibit 1
    glColor3f(1.2, 1, 0);
    glTranslatef(10, 5.0, -4.9);
    glScalef(3, 3, 1);
    glutSolidCube(1.0);
    exhibit[1][0] = 10;
    exhibit[1][1] = -5;
  glPopMatrix();

  glPushMatrix();                   // exhibit 2
    glColor3f(1.2, 1, 0);
    glTranslatef(-10, 5.0, -4.9);
    glScalef(3, 3, 1);
    glutSolidCube(1.0);
    exhibit[2][0] = -10;
    exhibit[2][1] = -5;
  glPopMatrix();

  glPushMatrix();                   // exhibit 3
    glColor3f(1.2, 1, 0);
    glTranslatef(7, 5.0, 4.9);
    glScalef(3, 3, 1);
    glutSolidCube(1.0);
    exhibit[3][0] = 7;
    exhibit[3][1] = 5;
  glPopMatrix();

  glPushMatrix();                   // exhibit 4
    glColor3f(1.2, 1, 0);
    glTranslatef(-7, 5.0, 4.9);
    glScalef(3, 3, 1);
    glutSolidCube(1.0);
    exhibit[4][0] = -7;
    exhibit[4][1] = 5;
  glPopMatrix();
}

void drawFloors(void)
{
  glPushMatrix();                   // floor - hallway #1
    glColor3f(1.0, 1.0, 1.0);
    glScalef(40, 1, 10);    
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // floor - hallway #2
    glTranslatef(25, 0, 0);
    glScalef(10, 1, 90);    
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // floor - hallway #3
    glTranslatef(-25, 0, 0);
    glScalef(10, 1, 90);    
    glutSolidCube(1.0);
  glPopMatrix();
}

void mapDisplay()
{
	glLoadIdentity();
    gluOrtho2D(-35.0, 35.0, -50.0, 50.0);
    glClear(GL_COLOR_BUFFER_BIT);
	glClearColor(0.4, 0.0, 0.0, 0.0);
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_QUADS);
		//floors
		glVertex2f(-30.0, -45.0);
		glVertex2f(-30.0, 45.0);
		glVertex2f(-20.0, 45.0);
		glVertex2f(-20.0, -45.0);
		glVertex2f(-20.0, -5.0);
		glVertex2f(-20.0, 5.0);
		glVertex2f(20.0, 5.0);
		glVertex2f(20.0, -5.0);
		glVertex2f(20.0, 45.0);
		glVertex2f(20.0, -45.0);
		glVertex2f(30.0, -45.0);
		glVertex2f(30.0, 45.0);
		glColor3f(1.0, 0.0, 1.0);//door
		glVertex2f(30, -7);
		glVertex2f(30, 7);
		glVertex2f(33, 7);
		glVertex2f(33, -7);
		glColor3f(0.1, 0.8, 0.2);//exhibits

/*    glTranslatef(0, 5.0, -4.9);
    glScalef(3, 3, 1);

    glTranslatef(10, 5.0, -4.9);
    glScalef(3, 3, 1);

    glTranslatef(-10, 5.0, -4.9);
    glScalef(3, 3, 1);

    glTranslatef(7, 5.0, 4.9);
    glScalef(3, 3, 1);

    glTranslatef(-7, 5.0, 4.9);
    glScalef(3, 3, 1);*/

		glVertex2f(3, 7);
		glVertex2f(3, 5);
		glVertex2f(-3, 5);
		glVertex2f(-3, 7);
		glVertex2f(7, 5);
		glVertex2f(7, 7);
		glVertex2f(13, 7);
		glVertex2f(13, 5);
		glVertex2f(-7, 5);
		glVertex2f(-7, 7);
		glVertex2f(-13, 7);
		glVertex2f(-13, 5);
		glVertex2f(4, -5);
		glVertex2f(4, -7);
		glVertex2f(10, -7);
		glVertex2f(10, -5);
		glVertex2f(-4, -5);
		glVertex2f(-4, -7);
		glVertex2f(-10, -7);
		glVertex2f(-10, -5);
	glEnd();
	float angle2 = angle * pi / 180;
	glColor3f(1.0, 0.0, 0.0);
	glBegin(GL_POLYGON);
		glVertex2f(eyex + 4 * cos(angle2), -eyez + -4 * sin(angle2));
		glVertex2f(eyex + 4 * cos(angle2 + 3 * pi / 4), -eyez + -4 * sin(angle2 + 3 * pi / 4));
		glVertex2f(eyex + 4 * cos(angle2 - 3 * pi / 4), -eyez + -4 * sin(angle2 - 3 * pi / 4));
	glEnd();
    glFlush();
    glutSwapBuffers();
    glutPostRedisplay();
}

void display(void)
{
    centerx = eyex + 5.0 * cos(angle * pi / 180.0);
    centerz = eyez + 5.0 * sin(angle * pi / 180.0);

    gluPerspective( 40.0, 1.0 , 0.1,  120.0);
    
    glMatrixMode(GL_MODELVIEW);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    gluLookAt(eyex, 5.0, eyez,  
              centerx, 5.0, centerz,  
              0.0, 1.0, 0.0);

    glClearColor(1.0, 1.0, 1.0, 0.0);

    glPushMatrix();

    /* Light */
    glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT0, GL_POSITION, light_position);

    /* Enable Various Components */
    glEnable(GL_COLOR_MATERIAL);  
    glEnable(GL_LIGHT0);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT);

    drawHalls();
    drawExhibits();
    drawFloors();

    glPopMatrix();
    glFlush();
    glutSwapBuffers();
	
    glutPostRedisplay();
	
}

void myReshape(int w, int h) 
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();   
    gluPerspective( 40.0, (GLfloat) h / (GLfloat) w , 0.1,  120.0);
    glMatrixMode(GL_MODELVIEW);
}

// collision detection--prevents user from going through walls
bool inBounds(float x, float z)
{
	if((x > -29 && x < -21) || (x > 21 && x < 29)) return z < 44.5 && z > -44.5;
	else if(x >= -21 && x <= 21) return z < 4.5 && z > -4.5;
	else return false;
}

// keyboard function--allows user to move around in museum
void keyboard(int key, int x, int y)
{
  float tempx, tempz;
  if(key == GLUT_KEY_LEFT) angle -= 2.0;
  else if(key == GLUT_KEY_RIGHT) angle += 2.0;
  else if(key == GLUT_KEY_UP) 
  {
    tempx = eyex + 0.2 * cos(angle * pi / 180.0);
    tempz = eyez + 0.2 * sin(angle * pi / 180.0);
	if(inBounds(tempx, tempz))
	{
		eyex = tempx;
		eyez = tempz;
	}
  }
  else if(key == GLUT_KEY_DOWN) 
  {
    tempx = eyex - 0.2 * cos(angle * pi / 180.0);
    tempz = eyez - 0.2 * sin(angle * pi / 180.0);
	if(inBounds(tempx, tempz))
	{
		eyex = tempx;
		eyez = tempz;
	}
  }
  glutPostRedisplay();	
  
  if(pic < 100)
	{
		if(screenShot()) cout << "Much Badness!" << endl;
		pic++;
	}
	
}

// mouse function--allows user to click on exhibits
void mouse(int button, int state, int x, int y)
{
	char* exhibitCall = new char[100];
  if (state == GLUT_DOWN)
  {
    for(int i=0; i <= numofexhibits; i++)
    {
      	if ((((exhibit[i][0] - centerx)*(exhibit[i][0] - centerx)) +
           ((exhibit[i][1] - centerz)*(exhibit[i][1] - centerz))) < 3)
		{
	  		cout << "Opening exhibit #" << i + 1 << endl;
			sprintf(exhibitCall, "netscape http://www.tjhsst.edu/~lpham/supercomp/imagine/videos/exhibit%i.html", i + 1);
			cout << exhibitCall << endl;
			system(exhibitCall);
			cout << "Exhibit #" << i + 1<< " closed\n";
		}
    }
  }
}

int main(int argc, char **argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
    glutInitWindowPosition(50, 50);
    glutInitWindowSize(500, 500);
    mainWin = glutCreateWindow("VirtualMuseum I");
    glutMouseFunc(mouse);
    glutSpecialFunc(keyboard);
    glutReshapeFunc(myReshape);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
/*    mapWin = glutCreateSubWindow(mainWin, 5, 5, 80, 80);
    glutDisplayFunc(mapDisplay);*/
    glutDisplayFunc(display);
	
    glutMainLoop();
    return 0;
}
